package com.zhongzheng.modules.recruit.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.recruit.bo.RecruitCompanyTradeAddBo;
import com.zhongzheng.modules.recruit.bo.RecruitCompanyTradeQueryBo;
import com.zhongzheng.modules.recruit.bo.RecruitCompanyTradeEditBo;
import com.zhongzheng.modules.recruit.domain.RecruitCompanyTrade;
import com.zhongzheng.modules.recruit.mapper.RecruitCompanyTradeMapper;
import com.zhongzheng.modules.recruit.vo.RecruitCompanyTradeVo;
import com.zhongzheng.modules.recruit.service.IRecruitCompanyTradeService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 行业类别Service业务层处理
 *
 * @author ruoyi
 * @date 2021-08-19
 */
@Service
public class RecruitCompanyTradeServiceImpl extends ServiceImpl<RecruitCompanyTradeMapper, RecruitCompanyTrade> implements IRecruitCompanyTradeService {

    @Override
    public RecruitCompanyTradeVo queryById(Long tradeId){
        RecruitCompanyTrade db = this.baseMapper.selectById(tradeId);
        return BeanUtil.toBean(db, RecruitCompanyTradeVo.class);
    }

    @Override
    public List<RecruitCompanyTradeVo> queryList(RecruitCompanyTradeQueryBo bo) {
        LambdaQueryWrapper<RecruitCompanyTrade> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getTradeName()), RecruitCompanyTrade::getTradeName, bo.getTradeName());
        lqw.eq(bo.getFather() != null, RecruitCompanyTrade::getFather, bo.getFather());
        lqw.eq(bo.getFatherId() != null, RecruitCompanyTrade::getFatherId, bo.getFatherId());
        lqw.eq(bo.getTenantId() != null, RecruitCompanyTrade::getTenantId, bo.getTenantId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<RecruitCompanyTradeVo> entity2Vo(Collection<RecruitCompanyTrade> collection) {
        List<RecruitCompanyTradeVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, RecruitCompanyTradeVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<RecruitCompanyTrade> page = (Page<RecruitCompanyTrade>)collection;
            Page<RecruitCompanyTradeVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(RecruitCompanyTradeAddBo bo) {
        RecruitCompanyTrade add = BeanUtil.toBean(bo, RecruitCompanyTrade.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(RecruitCompanyTradeEditBo bo) {
        RecruitCompanyTrade update = BeanUtil.toBean(bo, RecruitCompanyTrade.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(RecruitCompanyTrade entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<RecruitCompanyTradeVo> queryCompanyTradeVo(RecruitCompanyTradeQueryBo bo) {
        List<RecruitCompanyTradeVo> companyTradeVos = baseMapper.queryCompanyTradeVo(bo);
        return companyTradeVos;
    }
}
